%ifos darwin
%define __defattr       %defattr(-,root,wheel)
%else
%define __defattr       %defattr(-,root,root)
%endif

%define gs_ver 	  8.51

Summary: A PostScript(TM) interpreter and renderer.
Name: ghostscript
Version: %{gs_ver}
Release: 1a
License: AFPL
URL: http://www.cs.wisc.edu/~ghost/index.html
Group: Applications/Publishing

Source0: ftp://mirror.cs.wisc.edu/pub/mirrors/ghost/AFPL/gs851/%{name}-%{gs_ver}.tar.bz2
Source1: ftp://ftp.gyve.org/pub/gs-cjk/adobe-cmaps-200204.tar.gz
Source2: ftp://ftp.gyve.org/pub/gs-cjk/acro5-cmaps-2001.tar.gz
Source3: http://www.interq.or.jp/mars/cherry/mac/Font.tar.bz2
Source4: Hiragino-symlinks.tar.gz
Source20: CIDFnmap-cjk-osx20040807.tar.gz

Patch0: localhost:/%{name}-%{version}-macosx.patch

BuildRoot: %{_tmppath}/%{name}-root

%description
ESP Ghostscript is an enhanced version of GNU Ghostscript that
includes new printer drivers and support for the Common UNIX
Printing System.

%package devel
Summary: Files for developing applications that use ghostscript.
Requires: %{name} = %{version}
Group: Development/Libraries

%description devel
The header files for developing applications that use ghostscript.

%prep
%setup -q
%ifos darwin
%patch0 -p1 -b .macosx
%endif

%build
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} --bindir=%{_bindir} --mandir=%{_mandir}

# If we got this far, all prerequisite libraries must be here.
make
make so

%install
# Make sure destination directories are there, since Ghostscript doesn't make them...
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT%{_docdir}/ghostscript
mkdir -p $RPM_BUILD_ROOT%{_datadir}/ghostscript/%{gs_ver}/examples

make install soinstall 	prefix=$RPM_BUILD_ROOT%{_prefix} \
			install_prefix=$RPM_BUILD_ROOT \
			bindir=$RPM_BUILD_ROOT%{_bindir} \
			datadir=$RPM_BUILD_ROOT%{_datadir} \
			mandir=$RPM_BUILD_ROOT%{_mandir} \
			docdir=$RPM_BUILD_ROOT%{_docdir}/%{name}-%{gs_ver}

mkdir -p $RPM_BUILD_ROOT%{_prefix}/share/ghostscript/%{gs_ver}/Resource/{Font,CIDFont}
tar -zxvf %{SOURCE1} -C $RPM_BUILD_ROOT%{_prefix}/share/ghostscript/%{gs_ver}/Resource
tar -zxvf %{SOURCE2} -C $RPM_BUILD_ROOT%{_prefix}/share/ghostscript/%{gs_ver}/Resource
tar -jxvf %{SOURCE3} -C $RPM_BUILD_ROOT%{_prefix}/share/ghostscript/%{gs_ver}/Resource
%ifos darwin
tar -zxvf %{SOURCE4} -C $RPM_BUILD_ROOT%{_prefix}/share/ghostscript/%{gs_ver}/Resource
%endif
tar -zxvf %{SOURCE20} -C $RPM_BUILD_ROOT%{_prefix}/share/ghostscript/%{gs_ver}/lib


MAIN_PWD=`pwd`
(cd $RPM_BUILD_ROOT
 find .%{_datadir}/ghostscript/%{gs_ver}/lib/* | \
	sed -e 's/\.//;' | grep -v lib/Fontmap* | grep -v gs_init.ps > $MAIN_PWD/rpm.sharelist
 find .%{_bindir}/ -type f | sed -e 's/\.//;' | \
	grep -v 'gsx' >> $MAIN_PWD/rpm.sharelist
)

mkdir -p $RPM_BUILD_ROOT%{_includedir}/ghostscript
install -c -m 0644 src/iapi.h $RPM_BUILD_ROOT%{_includedir}/ghostscript
install -c -m 0644 src/errors.h $RPM_BUILD_ROOT%{_includedir}/ghostscript
install -c -m 0644 src/gdevdsp.h $RPM_BUILD_ROOT%{_includedir}/ghostscript
rm -rf $RPM_BUILD_ROOT%{_mandir}/de

%ifos darwin
# Use Hiragino on macosx
(cd $RPM_BUILD_ROOT
 pushd .%{_datadir}/ghostscript/%{gs_ver}/lib
 cat << EOF >> cidfmap
/Ryumin-Light 		/HiraMinPro-W3 ;
/Ryumin-Regular 	/HiraMinPro-W6 ;
/FutoMinA101-Bold 	/HiraKakuStd-W8 ;
/GothicBBB-Medium 	/HiraKakuPro-W3 ;
/FutoGoB101-Bold 	/HiraKakuPro-W6 ;
/Jun101-Light 		/HiraMaruPro-W4 ;
EOF
)
%endif


%clean
rm -rf $RPM_BUILD_ROOT

%files -f rpm.sharelist
%{__defattr}
%dir %{_datadir}/ghostscript
%dir %{_datadir}/ghostscript/%{gs_ver}
%dir %{_datadir}/ghostscript/%{gs_ver}/lib
%config %{_datadir}/ghostscript/%{gs_ver}/lib/gs_init.ps
%config %{_datadir}/ghostscript/%{gs_ver}/lib/Fontmap*
%{_datadir}/ghostscript/%{gs_ver}/Resource
%{_datadir}/ghostscript/%{gs_ver}/examples
%{_libdir}/*
%{_mandir}/man1/*
%doc %{_docdir}/%{name}-%{gs_ver}


%files devel
%{__defattr}
%dir %{_includedir}/ghostscript
%{_includedir}/ghostscript/*.h


%changelog
* Sat May 21 2005 Keisuke Fujii <keisuke.fujii@kek.jp> 8.51-1a
- 1st build on MacOS X 10.4.
